#include "smtp.h"
extern smtpi jtin;


void smtp_statistics_write(xmlnode loQuery,const char *lcTagName, const char *lcUnitName, const char *lcValue)
   {
   xmlnode loStatN;
   xmlnode_put_attrib(loStatN=xmlnode_insert_tag(loQuery,"stat"),"name",lcTagName);
   xmlnode_put_attrib(loStatN,"units",lcUnitName);
   xmlnode_put_attrib(loStatN,"value",lcValue); 
   }

int smtp_out_packets_iq_stats(smtpp par, char *type)
   {
   int liProcess=0,lii,liPom;
   jpacket jp=par->jp;
   char *lcPom;
   char *lcName,*lcNode,*lcSep;
   xmlnode loQuery, loStat,loJID,loFile;
   smtp_jq loQueue;
   smtp_jq_x loData;
   smtp_pools next=jtin->pools;

   lcNode=xmlnode_get_attrib(jp->iq,"node");
   loStat=xmlnode_get_firstchild(jp->iq);

   liPom=27;
   lcPom = (char*)pmalloc_x(par->tmppool, liPom+1,' ');
   lcPom[liPom] = '\0';

   // stats for transport-NODE, define
   if (liProcess==0 && j_strcmp(jp->iqns,NS_STATS)==0 &&
       jp->subtype==JPACKET__GET && jp->to->user==NULL && 
       j_strcmp(lcNode,"adminreports/memory")==0 && loStat==NULL
      )
      {
      loQueue=smtp_NewQueueItem(par->tmppool,SMTP_QUEUE_X);
      loData=(smtp_jq_x) loQueue->Data;
      loData->x=out_SetReply(xmlnode_new_tag("iq"),jp->x);
      smtp_PoolsReg(1282, xmlnode_pool(loData->x));

      xmlnode_put_attrib(loData->x,"type","result");
      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(loData->x,"query"),"xmlns",NS_STATS);
      xmlnode_put_attrib(loQuery,"node",lcNode);

      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","transport");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","poolmanagercore");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","poolmanagerdata");

/*
      while(next != NULL)
           {
           snprintf(lcPom, liPom, "pool:%i-%p",next->index,next->pl);
           xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name",lcPom);

           if (next->next != NULL)
              next = next->next;
           else
              break;
        }
*/

      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","all");

      liProcess=1;
      }


   // stats for transport-NODE, values
   if (liProcess==0 && j_strcmp(jp->iqns,NS_STATS)==0 &&
       jp->subtype==JPACKET__GET && jp->to->user==NULL && 
       j_strcmp(lcNode,"adminreports/memory")==0 && loStat!=NULL
      )
      {
      loQueue=smtp_NewQueueItem(par->tmppool,SMTP_QUEUE_X);
      loData=(smtp_jq_x) loQueue->Data;
      loData->x=out_SetReply(xmlnode_new_tag("iq"),jp->x);
      smtp_PoolsReg(1283, xmlnode_pool(loData->x));

      xmlnode_put_attrib(loData->x,"type","result");
      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(loData->x,"query"),"xmlns",NS_STATS);
      xmlnode_put_attrib(loQuery,"node",lcNode);

      // read all childs elements
      for (;loStat != NULL; loStat = xmlnode_get_nextsibling(loStat))
          {
          if (loStat->type!=NTYPE_TAG)
  	          continue;

          // main section
          lcName=xmlnode_get_attrib(loStat,"name");
          lcSep=strchr(lcName,'-');


          if (j_strcmp(lcName,"all")==0)
             {
             snprintf(lcPom, liPom, "%p\0",pool_size(jtin->i->p)+smtp_PoolsGetMem());
             smtp_statistics_write(loQuery,lcName, "bytes",lcPom);
		     continue;
             }

          if (j_strcmp(lcName,"transport")==0)
             {
             snprintf(lcPom, liPom, "%p\0",pool_size(jtin->i->p));
             smtp_statistics_write(loQuery,lcName, "bytes",lcPom);
		     continue;
             }

          if (j_strcmp(lcName,"poolmanagercore")==0)
             {
             lii=0;
             next=jtin->pools;
             while(next != NULL)
                {
                lii+=pool_size(next->p);

                if (next->next != NULL)
                   next = next->next;
                else
                   break;
                }
             snprintf(lcPom, liPom, "%p\0",lii);
             smtp_statistics_write(loQuery,lcName, "bytes",lcPom);
		     continue;
             }

          if (j_strcmp(lcName,"poolmanagerdata")==0)
             {
             lii=0;
             next=jtin->pools;
             while(next != NULL)
                {
                lii+=pool_size(next->pl);

                if (next->next != NULL)
                   next = next->next;
                else
                   break;
                }
             snprintf(lcPom, liPom, "%p\0",lii);
             smtp_statistics_write(loQuery,lcName, "bytes",lcPom);

             next=jtin->pools;
             while(next != NULL)
                {
                snprintf(lcPom, liPom, "%p\0",pool_size(next->pl));
//                smtp_statistics_write(loQuery,spools(par->tmppool,"poolmanagerdata-",smtp_itoa(par->tmppool,next->index),"-",smtp_itoa(par->tmppool,(int)next->pl)," (",next->cJID,")",par->tmppool), "bytes",lcPom);
                smtp_statistics_write(loQuery,spools(par->tmppool,"poolmanagerdata-",smtp_itoa(par->tmppool,next->index),"-",smtp_itoa(par->tmppool,(long long)next->pl),par->tmppool), "bytes",lcPom);

                if (next->next != NULL)
                   next = next->next;
                else
                   break;
                }


		     continue;

             }

          if (lcSep!=NULL)
             {
             next=jtin->pools;
             while(next != NULL)
                {
                if ((int)next->pl==j_atoi(lcSep+1,0))
                   {
                   snprintf(lcPom, liPom, "%p\0",pool_size(next->pl));
                   smtp_statistics_write(loQuery,lcName, "bytes",lcPom);
                   break;
                   }

                if (next->next != NULL)
                   next = next->next;
                else
                   break;
                }
             }
          }

      liProcess=1;
      }


   // stats for transport, define
   if (liProcess==0 && j_strcmp(jp->iqns,NS_STATS)==0 &&
       jp->subtype==JPACKET__GET && jp->to->user==NULL && 
       j_strlen(lcNode)==0 && loStat==NULL
      )
      {
      loQueue=smtp_NewQueueItem(par->tmppool,SMTP_QUEUE_X);
      loData=(smtp_jq_x) loQueue->Data;
      loData->x=out_SetReply(xmlnode_new_tag("iq"),jp->x);
      smtp_PoolsReg(1280, xmlnode_pool(loData->x));

      xmlnode_put_attrib(loData->x,"type","result");
      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(loData->x,"query"),"xmlns",NS_STATS);

      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","start");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","start/lastdatetime");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","memory");

      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","users");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","users/online");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","users/paid");

      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","contacts");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","contacts/online");

      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","accounts");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","accounts/elapsed");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","accounts/paid");

      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","jabber/status");

      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","jabber/messages");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","jabber/messages/out");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","jabber/messages/out/error");

      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","jabber/elapsed/messages");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","jabber/elapsed/messages/out");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","jabber/elapsed/messages/out/error");

      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/status");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/command/unknown");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/elapsed/command/unknown");

      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/messages");
	  xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/messages/in");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/messages/in/error");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/spam");
	  xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/maxsize");
	  xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/noprocess");
	  xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/bouncy");
	  xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/norecipient");
	  xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/spammers");

      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/elapsed/messages");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/elapsed/messages/in");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/elapsed/messages/in/error");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/elapsed/spam");
	  xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/elapsed/maxsize");
	  xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/elapsed/noprocess");
	  xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/elapsed/bouncy");
	  xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/elapsed/norecipient");
	  xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/elapsed/spammers");

      liProcess=1;
      }

   // stats for transport, values
   if (liProcess==0 && j_strcmp(jp->iqns,NS_STATS)==0 &&
       jp->subtype==JPACKET__GET && jp->to->user==NULL && 
       j_strlen(lcNode)==0 && loStat!=NULL
      )
      {
      loQueue=smtp_NewQueueItem(par->tmppool,SMTP_QUEUE_X);
      loData=(smtp_jq_x) loQueue->Data;
      loData->x=out_SetReply(xmlnode_new_tag("iq"),jp->x);
      smtp_PoolsReg(1281, xmlnode_pool(loData->x));

      xmlnode_put_attrib(loData->x,"type","result");
      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(loData->x,"query"),"xmlns",NS_STATS);

      // read all childs elements
      for (;loStat != NULL; loStat = xmlnode_get_nextsibling(loStat))
          {
          if (loStat->type!=NTYPE_TAG)
  	          continue;

          // main section
          lcName=xmlnode_get_attrib(loStat,"name");
          if (j_strcmp(lcName,"start")==0)
             {
             snprintf(lcPom, liPom, "%i\0",jtin->Stats->Start);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
		     continue;
             }

          if (j_strcmp(lcName,"start/lastdatetime")==0)
             {
             smtp_statistics_write(loQuery,lcName, "date",jtin->Stats->StartLastDatetime);
		     continue;
             }


          if (j_strcmp(lcName,"memory")==0)
             {
             // smtp_rjidGetMem() pamt online rosteru
             // smtp_CmdGetMem() pamt pkazov fronty
             // pool_size(jtin->resources->p) pamt zabrajc zdroje
             // 
             //if (jtin->roster->p!=jtin->i->p)
             //   lii+=pool_size(jtin->roster->p);

             lii=pool_size(jtin->i->p)+smtp_PoolsGetMem();
             snprintf(lcPom, liPom, "%p\0",lii);
             smtp_statistics_write(loQuery,lcName, "bytes",lcPom);
		     continue;
             }

          if (j_strcmp(lcName,"users")==0)
             {
             snprintf(lcPom, liPom, "%p\0",smtp_cjidGetCount(0));
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }


          if (j_strcmp(lcName,"users/online")==0)
             {
             lii=0;
             snprintf(lcPom, liPom, "%p\0",lii);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }


          if (j_strcmp(lcName,"users/paid")==0)
             {
             snprintf(lcPom, liPom, "%p\0",smtp_cjidGetCount(1));
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }
 


          if (j_strcmp(lcName,"contacts")==0)
             {
             snprintf(lcPom, liPom, "%p\0",smtp_cjidGetContactsCount());
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"contacts/online")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->_CoreContactsOnline);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"accounts")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->_CoreAccounts);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"accounts/elapsed")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->CoreAccounts);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"accounts/paid")==0)
             {
             lii=0;
             for (loFile = xmlnode_get_tag(jtin->roster_files,"file"); loFile != NULL; loFile = xmlnode_get_nextsibling(loFile))
                 {
                 if (loFile->type!=NTYPE_TAG)
                    continue;

                 // walk all jid in file
                 for (loJID = xmlnode_get_tag(loFile,"item"); loJID != NULL; loJID = xmlnode_get_nextsibling(loJID))
                     {
                     if (loJID->type!=NTYPE_TAG || j_atoi(xmlnode_get_attrib(loJID,"paid"),0)!=0)
                        lii++;
                     }
                 }

             snprintf(lcPom, liPom, "%p\0",lii);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          // jabber side
          if (j_strcmp(lcName,"jabber/status")==0)
             {
             smtp_statistics_write(loQuery,lcName, "text",jtin->cJabber_Status);
             continue;
             }

          if (j_strcmp(lcName,"jabber/messages")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->_JabberMessages);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"jabber/messages/out")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->_JabberMessagesOut);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"jabber/messages/out/error")==0)
             {
             snprintf(lcPom, liPom, "%i\0",jtin->Stats->_JabberMessagesOutError);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"jabber/elapsed/messages")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->JabberMessages);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"jabber/elapsed/messages/out")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->JabberMessagesOut);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }


          if (j_strcmp(lcName,"jabber/elapsed/messages/out/error")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->JabberMessagesOutError);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          // SMTP side
          if (j_strcmp(lcName,"smtp/status")==0)
             {
             smtp_statistics_write(loQuery,lcName, "text",jtin->cSMTP_Status);
             continue;
             }

          if (j_strcmp(lcName,"smtp/command/unknown")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->_SMTPCommandUnknown);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/elapsed/command/unknown")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->SMTPCommandUnknown);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/messages")==0)
             {
             snprintf(lcPom, sizeof(lcPom), "%p\0",jtin->Stats->_SMTPMessages);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }


          if (j_strcmp(lcName,"smtp/messages/in")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->_SMTPMessagesIn);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/messages/in/error")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->_SMTPMessagesInError);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/elapsed/messages")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->SMTPMessages);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/elapsed/messages/in")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->SMTPMessagesIn);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/elapsed/messages/in/error")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->SMTPMessagesInError);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/spam")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->_SMTPSpam);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/elapsed/spam")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->SMTPSpam);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/elapsed/noprocess")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->SMTPNoProcess);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/noprocess")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->_SMTPNoProcess);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/elapsed/bouncy")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->SMTPBouncy);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/bouncy")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->_SMTPBouncy);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/elapsed/maxsize")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->SMTPMaxSize);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/maxsize")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->_SMTPMaxSize);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/elapsed/norecipient")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->SMTPNoRecipient);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/norecipient")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->_SMTPNoRecipient);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/elapsed/spammers")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->SMTPSpammers);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }

          if (j_strcmp(lcName,"smtp/spammers")==0)
             {
             snprintf(lcPom, liPom, "%p\0",jtin->Stats->_SMTPSpammers);
             smtp_statistics_write(loQuery,lcName, "count",lcPom);
             continue;
             }


         }

      liProcess=1;
      }


   if (liProcess==1)
      smtp_FlushQueue(par->i, loQueue);


   return liProcess;
   }
